DG.GridAutoload = new Class({

    tableEl : null,

    initialize : function(){

    },

    columnConfig : [],

    getConfigObject : function(el){
        this.tableEl = el;

        this.setColumnConfig();
        var size = this.getSize();

        return {
            behaviour : {
                closable : false,
                resizable : true,
                minimizable : false
            },
            height: size.y,
            width : size.x,
            stretch : true,
            title : this.getTitle(),
            columnConfig : this.columnConfig,
            data : this.getData()
        }
    },

    getTitle : function(){
        var caption = this.tableEl.getElement('caption');
        if(caption){
            return caption.get('html');
        }
        return '';
    },

    setColumnConfig : function(){
        var ret = [];
        var row = this.tableEl.getElements('tr')[0];
        var cells = row.getElements('td');
        countCells = cells.length;

        for(var i=0;i<countCells;i++){
            ret.push({
                width : cells[i].getSize().x,
                sortable : true,
                movable : true,
                key : cells[i].get('html').replace(/\s/g,'_'),
                heading : cells[i].get('html')
            })
        }

        this.columnConfig = ret;

    },

    getSize : function() {
        var size = this.tableEl.getSize();
        var gridHeightProperty = this.tableEl.getProperty('gridHeight');
        return {
            x : size.x,
            y : gridHeightProperty ? gridHeightProperty / 1 : size.y + 50
        } ;
    },

    getData : function() {
        var ret = [];
        var rows = this.tableEl.getElements('tr');

        for(var i=1, count=rows.length; i<count; i++){
            var cells = rows[i].getElements('td');
            var obj = {};
            for(var j=0, countCols = this.columnConfig.length; j<countCols; j++){
                obj[this.columnConfig[j].key] = cells[j].get('html');
            }
            ret.push(obj);
        }
        return ret;
    },

    hasTheadElement : function(){
        return this.tableEl.getElements('thead').length > 0;
    }
});

window.addEvent('domready', function() {
    var gridAutoLoadObject = new DG.GridAutoload();
    var els = $$('.table-dg-grid');
    for(var i=0;i<els.length;i++){
        var gridConfig = gridAutoLoadObject.getConfigObject(els[i]);
        console.log(gridConfig);
        var grid = new DG.Grid(gridConfig);
        grid.getEl().inject(els[i], 'before');
        els[i].setStyle('display', 'none');
    }
});